/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the JsonXmlObject type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &JsonXmlObject{}

// JsonXmlObject struct for JsonXmlObject
type JsonXmlObject struct {
	Name      NullableString `json:"name,omitempty"`
	Wrapped   *bool          `json:"wrapped,omitempty"`
	Namespace NullableString `json:"namespace,omitempty"`
	Prefix    NullableString `json:"prefix,omitempty"`
	Attribute *bool          `json:"attribute,omitempty"`
}

// NewJsonXmlObject instantiates a new JsonXmlObject object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewJsonXmlObject() *JsonXmlObject {
	this := JsonXmlObject{}
	return &this
}

// NewJsonXmlObjectWithDefaults instantiates a new JsonXmlObject object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewJsonXmlObjectWithDefaults() *JsonXmlObject {
	this := JsonXmlObject{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonXmlObject) GetName() string {
	if o == nil || IsNil(o.Name.Get()) {
		var ret string
		return ret
	}
	return *o.Name.Get()
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonXmlObject) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Name.Get(), o.Name.IsSet()
}

// HasName returns a boolean if a field has been set.
func (o *JsonXmlObject) HasName() bool {
	if o != nil && o.Name.IsSet() {
		return true
	}

	return false
}

// SetName gets a reference to the given NullableString and assigns it to the Name field.
func (o *JsonXmlObject) SetName(v string) {
	o.Name.Set(&v)
}

// SetNameNil sets the value for Name to be an explicit nil
func (o *JsonXmlObject) SetNameNil() {
	o.Name.Set(nil)
}

// UnsetName ensures that no value is present for Name, not even an explicit nil
func (o *JsonXmlObject) UnsetName() {
	o.Name.Unset()
}

// GetWrapped returns the Wrapped field value if set, zero value otherwise.
func (o *JsonXmlObject) GetWrapped() bool {
	if o == nil || IsNil(o.Wrapped) {
		var ret bool
		return ret
	}
	return *o.Wrapped
}

// GetWrappedOk returns a tuple with the Wrapped field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonXmlObject) GetWrappedOk() (*bool, bool) {
	if o == nil || IsNil(o.Wrapped) {
		return nil, false
	}
	return o.Wrapped, true
}

// HasWrapped returns a boolean if a field has been set.
func (o *JsonXmlObject) HasWrapped() bool {
	if o != nil && !IsNil(o.Wrapped) {
		return true
	}

	return false
}

// SetWrapped gets a reference to the given bool and assigns it to the Wrapped field.
func (o *JsonXmlObject) SetWrapped(v bool) {
	o.Wrapped = &v
}

// GetNamespace returns the Namespace field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonXmlObject) GetNamespace() string {
	if o == nil || IsNil(o.Namespace.Get()) {
		var ret string
		return ret
	}
	return *o.Namespace.Get()
}

// GetNamespaceOk returns a tuple with the Namespace field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonXmlObject) GetNamespaceOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Namespace.Get(), o.Namespace.IsSet()
}

// HasNamespace returns a boolean if a field has been set.
func (o *JsonXmlObject) HasNamespace() bool {
	if o != nil && o.Namespace.IsSet() {
		return true
	}

	return false
}

// SetNamespace gets a reference to the given NullableString and assigns it to the Namespace field.
func (o *JsonXmlObject) SetNamespace(v string) {
	o.Namespace.Set(&v)
}

// SetNamespaceNil sets the value for Namespace to be an explicit nil
func (o *JsonXmlObject) SetNamespaceNil() {
	o.Namespace.Set(nil)
}

// UnsetNamespace ensures that no value is present for Namespace, not even an explicit nil
func (o *JsonXmlObject) UnsetNamespace() {
	o.Namespace.Unset()
}

// GetPrefix returns the Prefix field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonXmlObject) GetPrefix() string {
	if o == nil || IsNil(o.Prefix.Get()) {
		var ret string
		return ret
	}
	return *o.Prefix.Get()
}

// GetPrefixOk returns a tuple with the Prefix field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonXmlObject) GetPrefixOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Prefix.Get(), o.Prefix.IsSet()
}

// HasPrefix returns a boolean if a field has been set.
func (o *JsonXmlObject) HasPrefix() bool {
	if o != nil && o.Prefix.IsSet() {
		return true
	}

	return false
}

// SetPrefix gets a reference to the given NullableString and assigns it to the Prefix field.
func (o *JsonXmlObject) SetPrefix(v string) {
	o.Prefix.Set(&v)
}

// SetPrefixNil sets the value for Prefix to be an explicit nil
func (o *JsonXmlObject) SetPrefixNil() {
	o.Prefix.Set(nil)
}

// UnsetPrefix ensures that no value is present for Prefix, not even an explicit nil
func (o *JsonXmlObject) UnsetPrefix() {
	o.Prefix.Unset()
}

// GetAttribute returns the Attribute field value if set, zero value otherwise.
func (o *JsonXmlObject) GetAttribute() bool {
	if o == nil || IsNil(o.Attribute) {
		var ret bool
		return ret
	}
	return *o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonXmlObject) GetAttributeOk() (*bool, bool) {
	if o == nil || IsNil(o.Attribute) {
		return nil, false
	}
	return o.Attribute, true
}

// HasAttribute returns a boolean if a field has been set.
func (o *JsonXmlObject) HasAttribute() bool {
	if o != nil && !IsNil(o.Attribute) {
		return true
	}

	return false
}

// SetAttribute gets a reference to the given bool and assigns it to the Attribute field.
func (o *JsonXmlObject) SetAttribute(v bool) {
	o.Attribute = &v
}

func (o JsonXmlObject) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o JsonXmlObject) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Name.IsSet() {
		toSerialize["name"] = o.Name.Get()
	}
	if !IsNil(o.Wrapped) {
		toSerialize["wrapped"] = o.Wrapped
	}
	if o.Namespace.IsSet() {
		toSerialize["namespace"] = o.Namespace.Get()
	}
	if o.Prefix.IsSet() {
		toSerialize["prefix"] = o.Prefix.Get()
	}
	if !IsNil(o.Attribute) {
		toSerialize["attribute"] = o.Attribute
	}
	return toSerialize, nil
}

type NullableJsonXmlObject struct {
	value *JsonXmlObject
	isSet bool
}

func (v NullableJsonXmlObject) Get() *JsonXmlObject {
	return v.value
}

func (v *NullableJsonXmlObject) Set(val *JsonXmlObject) {
	v.value = val
	v.isSet = true
}

func (v NullableJsonXmlObject) IsSet() bool {
	return v.isSet
}

func (v *NullableJsonXmlObject) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJsonXmlObject(val *JsonXmlObject) *NullableJsonXmlObject {
	return &NullableJsonXmlObject{value: val, isSet: true}
}

func (v NullableJsonXmlObject) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJsonXmlObject) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
